/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of OpenIsis.xs. Do not edit this file, edit OpenIsis.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "OpenIsis.xs"
/*
	openisis - an open implementation of the ISIS database
	Version 0.8.x (microversion see file Version)
	Copyright (C) 2001-2002 by Erik Grziwotz, erik@openisis.org

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	This software is dedicated to the memory of Eckart Dietrich.

	This software is inspired by (but contains no code of) the iAPI
	Copyright (C) 2000 by Robert Janusz, rj@jezuici.krakow.pl.
	See iAPI.txt for what it contains.
EOH */

/*
	$Id: OpenIsis.xs,v 1.12 2002/12/04 14:16:34 kripke Exp $
	the openisis XSUB
*/


#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef assert
#undef assert /* perl.h assert doesn't really assert */
#endif
#include <assert.h>

#include "openisis.h"

	//ADDED:// next 4 lines
#if !defined( __STDC__ ) && defined ( WIN32 )
#define snprintf _snprintf
#define alloca  _alloca
#endif 

#line 60 "OpenIsis.c"
XS(XS_OpenIsis_log); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenIsis_log)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: OpenIsis::log(level, file)");
    {
	int	level = (int)SvIV(ST(0));
	char*	file = (char *)SvPV_nolen(ST(1));
#line 58 "OpenIsis.xs"
	openIsisLog( level, *file ? file : NULL );
#line 72 "OpenIsis.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_OpenIsis_open); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenIsis_open)
{
    dXSARGS;
    if (items < 1)
	Perl_croak(aTHX_ "Usage: OpenIsis::open(name, ...)");
    {
	char*	name = (char *)SvPV_nolen(ST(0));
	int	RETVAL;
	dXSTARG;
#line 64 "OpenIsis.xs"
	{
		const char **argv = NULL;
		int argc = 0;
		if ( 1 < items ) {
			STRLEN n_a;
			int i;
			argv = (const char **)malloc( (items-1) * sizeof(argv[0]) );
			for ( i=1; i<items; i++ )
				/* TODO: should take care to make 0-term copies */
				argv[i-1] = (char *)SvPV(ST(i), n_a);
			argc = items-1;
		}
		RETVAL = openIsisOpen( name, argv, argc );
		if ( NULL != argv )
			free( argv );
	}
#line 104 "OpenIsis.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_OpenIsis_maxRowid); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenIsis_maxRowid)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: OpenIsis::maxRowid(db)");
    {
	int	db = (int)SvIV(ST(0));
	long	RETVAL;
	dXSTARG;
#line 87 "OpenIsis.xs"
	RETVAL = openIsisMaxRowid( db );
#line 122 "OpenIsis.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_OpenIsis_2html); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenIsis_2html)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: OpenIsis::2html(str)");
    {
	char*	str = (char *)SvPV_nolen(ST(0));
	SV *	RETVAL;
#line 95 "OpenIsis.xs"
	{
		str = openIsis2Html( str, -1 );
		RETVAL = newSVpv( str, 0 );
	}
#line 142 "OpenIsis.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_OpenIsis_read); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenIsis_read)
{
    dXSARGS;
    if (items < 2)
	Perl_croak(aTHX_ "Usage: OpenIsis::read(db, rowid, ...)");
    {
	int	db = (int)SvIV(ST(0));
	long	rowid = (long)SvIV(ST(1));
	SV *	RETVAL;
#line 107 "OpenIsis.xs"
	{
		HV *hv = newHV();
		OpenIsisRec *r = openIsisReadRow( db, rowid );
		if ( NULL != r ) {
			union { OpenIsisRec r; char buf[10000]; } x;
			int i;
			hv_store( hv, "mfn", 3, newSViv( r->rowid ), 0 );
			if ( items > 2 ) {
#ifdef SvPV_nolen
	/* 5.6.x has this. see man perlguts for why it's useful.  */
				char *fmt = (char *)SvPV_nolen( ST(2) );
#else
				STRLEN unused;
				char *fmt = (char *)SvPV( ST(2), unused );
#endif
				OpenIsisRec *q;
				OPENISIS_INITBUF(x);
				q = openIsisFmt( &x.r, fmt, r );
	//CHANGED:// 	added test alloca, without this test openisis.dll crashed
#ifndef alloca
				free( r );
#endif
				r = q;
			}
			for ( i=0; i < r->len; i++ ) {
				char buf[7];
				AV *ar;
				SV *ref, **entry;
				SV *val;
				val = newSVpv( (char*)r->field[i].val, r->field[i].len );
				snprintf( buf, sizeof(buf), "%hu", r->field[i].tag );
				buf[sizeof(buf)-1] = 0;
				entry = hv_fetch( hv, buf, strlen(buf), 1 );
				assert ( NULL != entry ); /* out of memory */
				if ( NULL == *entry || ! SvROK(*entry) ) {
					ar = newAV();
					*entry = newRV_noinc((SV*)ar);
				} else {
					ar = (AV*)SvRV(*entry);
					assert( SVt_PVAV == SvTYPE(ar) );
				}
				av_push( ar, val );
			}
	//CHANGED:// 	added test alloca, without this test openisis.dll crashed
#ifndef alloca
			if ( r != &x.r )
				{
				free( r );
				}
#endif
		}
		RETVAL = newRV_noinc( (SV*)hv );
	}
#line 213 "OpenIsis.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_OpenIsis_subfields); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenIsis_subfields)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: OpenIsis::subfields(field)");
    {
	char *	field = (char *)SvPV_nolen(ST(0));
	SV *	RETVAL;
#line 167 "OpenIsis.xs"
	{
		OpenIsisField f;
		OpenIsisRec *r;
		HV *hv = newHV();

		f.tag = 0;
		f.val = field;
		f.len = strlen(field);
		r = openIsisReadField( NULL, &f );
		if ( NULL != r ) {
			int i;
			char buf[2];
			buf[sizeof(buf)-1] = 0;
			for ( i=0; i < r->len; i++ ) {
				buf[0] = (char)r->field[i].tag;
				hv_store( hv, buf, buf[0] ? 1 : 0,
					newSVpv( (char*)r->field[i].val, r->field[i].len ), 0 );
			}
	//CHANGED:// 	added test alloca, without this test openisis.dll crashed
#ifndef alloca
			free( r );//Oego
#endif
		}
		RETVAL = newRV_noinc( (SV*)hv );
	}
#line 255 "OpenIsis.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_OpenIsis_query); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenIsis_query)
{
    dXSARGS;
    if (items < 2)
	Perl_croak(aTHX_ "Usage: OpenIsis::query(db, key, ...)");
    SP -= items;
    {
	int	db = (int)SvIV(ST(0));
	char *	key = (char *)SvPV_nolen(ST(1));
#line 200 "OpenIsis.xs"
	{
		long mode = OPENISIS_QRY_SIMPLE;
		long skip = 0;
		int got;
		OpenIsisSet set;
		set.len = 0;
		got = (int)openIsisQuery( &set, db, key, mode, skip );
		if ( 0 < got ) {
			int i;
			EXTEND(SP,got);
			for ( i=0; i<got; i++ )
				PUSHs(sv_2mortal(newSViv(set.id[i])));
		}
	}
#line 287 "OpenIsis.c"
	PUTBACK;
	return;
    }
}

XS(XS_OpenIsis_terms); /* prototype to pass -Wmissing-prototypes */
XS(XS_OpenIsis_terms)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: OpenIsis::terms(db, key)");
    SP -= items;
    {
	int	db = (int)SvIV(ST(0));
	char *	key = (char *)SvPV_nolen(ST(1));
#line 220 "OpenIsis.xs"
	{
		int got = 0, i;
		union { OpenIsisRec r; char buf[10000]; } x;
		x.r.len   = 0;
		x.r.bytes = sizeof(x);
		while ( NULL != openIsisTerm( &x.r, db, key ) && x.r.len ) {
			got += (int)x.r.len;
			EXTEND(SP,got);
			/* printf( "%ld terms\n", x.r.len ); */
			for ( i=0; i<x.r.len; i++ )
				PUSHs(sv_2mortal(newSVpv( (char*)x.r.field[i].val, x.r.field[i].len )));

		}
	}
#line 318 "OpenIsis.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_OpenIsis); /* prototype to pass -Wmissing-prototypes */
XS(boot_OpenIsis)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXSproto("OpenIsis::log", XS_OpenIsis_log, file, "$$");
        newXSproto("OpenIsis::open", XS_OpenIsis_open, file, "$;@");
        newXSproto("OpenIsis::maxRowid", XS_OpenIsis_maxRowid, file, "$");
        newXSproto("OpenIsis::2html", XS_OpenIsis_2html, file, "$");
        newXSproto("OpenIsis::read", XS_OpenIsis_read, file, "$$;@");
        newXSproto("OpenIsis::subfields", XS_OpenIsis_subfields, file, "$");
        newXSproto("OpenIsis::query", XS_OpenIsis_query, file, "$$;@");
        newXSproto("OpenIsis::terms", XS_OpenIsis_terms, file, "$$");
    XSRETURN_YES;
}

